unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ShellApi, DLog;

const
  {$I CompConstants.inc}

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet4: TTabSheet;
    Shape3: TShape;
    Label6: TLabel;
    Label4: TLabel;
    TabSheet3: TTabSheet;
    Shape5: TShape;
    Label7: TLabel;
    Label12: TLabel;
    TabSheet2: TTabSheet;
    Shape2: TShape;
    Label2: TLabel;
    Panel1: TPanel;
    Button2: TButton;
    Button3: TButton;
    Button1: TButton;
    LoggingCheckBox: TCheckBox;
    Shape9: TShape;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    Button4: TButton;
    TabSheet1: TTabSheet;
    Image1: TImage;
    Shape1: TShape;
    Label1: TLabel;
    Shape6: TShape;
    Label3: TLabel;
    Label13: TLabel;
    TabSheet6: TTabSheet;
    Shape7: TShape;
    Label14: TLabel;
    Label15: TLabel;
    Button5: TButton;
    Shape8: TShape;
    Label16: TLabel;
    Shape10: TShape;
    Label17: TLabel;
    Label18: TLabel;
    Label5: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label8: TLabel;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    TabSheet5: TTabSheet;
    Shape4: TShape;
    Label24: TLabel;
    Label25: TLabel;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    DebugLog1: TDebugLog;
    Image6: TImage;
    Label34: TLabel;
    Label33: TLabel;
    TabSheet7: TTabSheet;
    Shape11: TShape;
    Label35: TLabel;
    Label36: TLabel;
    Image10: TImage;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Image11: TImage;
    Label40: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure LoggingCheckBoxClick(Sender: TObject);
    procedure DebugLog1Debug(Sender: TObject; Choice: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Label19Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Enumerate Windows CallBack Function
function EnumWindowsCallBack(Window: HWnd; LPARAM:LParam):bool stdcall;
const
  MaxWTextLength = 1024;
var
  WindowText: String;
begin
  // Find the Name of the Window
  SetLength(WindowText, MaxWTextLength);
  SetLength(WindowText, GetWindowText(Window, PChar(WindowText), MaxWTextLength));

  // Add the Window Handle and Window Name to the Debug Log
  if Length(Trim(WindowText)) > 0 then
    Form1.DebugLog1.Add('EnumWindows', [Format('%x', [Window]), WindowText]); // Add Hex & String Value

  Result := True; // Continue Enumeration
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // Hide Debug Log
  DebugLog1.Hide;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // Show the Debug Log
  DebugLog1.Show;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  // Add CheckBox State to Debug Log
  DebugLog1.Add('Checkbox', [CheckBox1.Checked]); // Adding a Boolean Value
end;

procedure TForm1.LoggingCheckBoxClick(Sender: TObject);
begin
  // Start/Stop Logging
  DebugLog1.Logging := TCheckBox(Sender).Checked;
end;

procedure TForm1.DebugLog1Debug(Sender: TObject; Choice: Integer);
var
  i: Integer;
  SearchRec: TSearchRec;

begin
{ This is OnDebug Event, you can put all manner of Debug Code here that you want
  to Log. Just make sure you give names for each Debug Choice; for each Integer
  value in the Choice block you must also have a String description in the
  TDebugLog.Captions property. These are the Strings that will display in the
  Debug ComboBox of the Top-Right corner of the Debug Log Window.               }

  case Choice of
    0: // Enumerate All Windows
    with DebugLog1 do
    begin
      // Start Logging
      Show; // Show Debug Log
      BeginUpdate; // Don't view each entry as it's being logged...
      try
        EnumWindows(@EnumWindowsCallBack, 0); // Enumerate Windows (and Log them)
      finally
        EndUpdate; // ... only when it's done (saves time this way)
      end;
    end;

    1: // List Components on Form
    try
      DebugLog1.BeginUpdate;

      for i := 0 to ComponentCount - 1 do
        with Components[i] do // Add Component Name, Index & Tag
          DebugLog1.Add('Components (Name/Index/Tag)', [Name,           // String Value
                                                        ComponentIndex, // Integer Value
                                                        Tag]);          // Integer Value

    finally
      DebugLog1.EndUpdate;
    end;

    2: // List Files in Current Directory
    with DebugLog1 do
    try
      BeginUpdate;

      if FindFirst('*.*', 0, SearchRec) = 0 then // Find First File
      repeat
        with SearchRec do // Add to Log
          Add('Files (Name/Size/Time)', [Name,                         // String Value
                                         Format('%.0fk', [Size/1024]), // String Value
                                         FileDateToDateTime(Time)]);   // TDateTime Value
      until FindNext(SearchRec) <> 0;

    finally
      FindClose(SearchRec); // Free SearchRec
      EndUpdate;
    end;

    3: // Calculate Square Roots - Floating Point Example
    with DebugLog1 do
    try
      BeginUpdate;

      for i := 0 to 25 do
        Add('SquareRoot', [i, Sqrt(i)]); // Add Floating Point Value

    finally
      EndUpdate;
    end;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Ensure Logging Check Box Displays the Correct Value
  LoggingCheckBox.Checked := DebugLog1.Logging;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DebugLog1.Clear;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  DebugLog1.AddStrings('Countries', ListBox1.Items); // Add Entire TStrings Object
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  with Sender as TListBox do
    DebugLog1.Add('Country Selected', [Items[ItemIndex]]); // Add String Value
end;

procedure TForm1.Button5Click(Sender: TObject);
const
  cString = 'TDebug Log Loop Example';
var
  i: Integer;
begin
  { Note: You can use BeginUpdate to speed things up in here, but if you do that
    you won't see what's going on as it happens, of course that doesn't really
    matter in this example as the loop is quite fast. Please see the OnDebug
    event to see how BeginUpdate works}

  for i := 0 to Length(cString) -1 do
    DebugLog1.Add('Loop Example', [Copy(cString, 1, i +1)]); // Add String Value
end;

procedure TForm1.Label19Click(Sender: TObject);
begin
  // Visit our Web Page
  ShellExecute(0, PChar('open'), PChar(cComponentsWebSite), PChar(''), PChar(''), SW_SHOWNORMAL);
end;

end.
